/****************************************************************************************************
 * NAME : OpenGL demo one																			*
 * AUTEUR : eXor (Combes Bertrand)		http://exor.free.fr											*
 * DATE : 07/10/2000																				*
 * PLATFORM : Win32 & Carte vido compatible OpenGL													*
 ****************************************************************************************************/

// Autre entete

#include "windows.h"
#include "stdio.h"		// Pour l'acces au fichier


// entete OpenGL
#include "gl\gl.h"
#include "gl\glu.h"
#include "gl\glaux.h"

/****************************************************************************************************
 * Macro																							*
 ****************************************************************************************************/
#define PI 3.1415926535				// euh PI c'est quoi ^_^ lol
#define RADIAN(X) ((X)*PI/180)		// Macro qui tranforme les degres en radians


/****************************************************************************************************
 * Structure																						*
 ****************************************************************************************************/


/****************************************************************************************************
 * Variables systemes																				*
 ****************************************************************************************************/
HGLRC	hRC = NULL;		// Rendering Context
HDC		hDC = NULL;		// Device Context
HWND	hWnd = NULL;	// Handle Of The Window
HINSTANCE	hInstance;	// Instance de l'application

/****************************************************************************************************
 * Variables globales																				*
 ****************************************************************************************************/
bool	keys[256];			// Matrice clavier
bool	active = TRUE;		// Pour savoir si la fenetre est minimiser
bool	fullscreen = TRUE;	// Pour savoir si on est en plein ecran

GLuint	texture[3];		// Place pour 3 textures

/****************************************************************************************************
 * Prototypes de Fonctions/Procedures																*
 ****************************************************************************************************/
LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Necessaire a tout programme Windows pour gerer les evenements
GLvoid ReSizeGLScene(GLsizei width, GLsizei height);	// Redimensionne et initialize la "GL Window"
int InitGL(GLvoid);				// Initialise OpenGL (ZBuffer,smooth shading,qualite d'affichage,etc..)
int DrawGLScene(GLvoid);		// C'est cette fonction qui affiche tout !!!
GLvoid KillGLWindow(GLvoid);	// Supprime la fenetre OpenGL
BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag);	// Creation de la fenetre
BOOL LoadBMP(char *fichier, int index);

/****************************************************************************************************
 * Point d'entr du programme																		*
 ****************************************************************************************************/
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	MSG		msg;				// Windows Message structure
	BOOL	done=FALSE;			//Variable exit


	if(MessageBox(NULL,"Passer en mode plein cran?", "Mode vido",MB_YESNO|MB_ICONQUESTION)==IDNO)
		fullscreen = FALSE;

	// Quitte si la fentre n'a pas pu etre cr
	if (!CreateGLWindow("Demo OpenGL",800,600,16,fullscreen)) return 0;

// Boucle principale
	while(!done)
	{
// Ici on place notre code




// Gestion des messages
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
		{
			if(msg.message == WM_QUIT) done = TRUE;
			else
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
		else
		{
			if(active && keys[VK_ESCAPE]) done = TRUE;
			else
			{
				DrawGLScene();
				SwapBuffers(hDC);
			}
		}
	}


// On quitte l'application
	KillGLWindow();						// Ferme la fenetre
	return (msg.wParam);				// Fin du programme
}

/****************************************************************************************************
 * Fonctions et Procedures																			*
 ****************************************************************************************************/
int DrawGLScene(GLvoid)
{
	static int numBMP = 0, tempo = 0, tempomax  = 70;
	static GLfloat rotx = 0.0f, roty = 0.0f, rotz = 0.0f, vitesse = 1.0f, translation = 5.0f;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
	glLoadIdentity();									// Reset The Current Modelview Matrix

	// Changement dynamique de la vitesse de rotation
	if(keys[VK_ADD]) vitesse += 0.05f;
	if(keys[VK_SUBTRACT]) vitesse -= 0.05f;
	if(vitesse <= 0) vitesse = 0.0f;

	rotx+=0.3f * vitesse;								// X Axis Rotation
	roty+=0.2f * vitesse;								// Y Axis Rotation
	rotz+=0.4f * vitesse;								// Z Axis Rotation

	if(keys[VK_UP]) translation -= 0.3f;
	if(keys[VK_DOWN]) translation += 0.3f;
	if(translation >= -5.0f) translation = -5.0f;

	glTranslatef(0.0f, 0.0f, translation);

	glRotatef(rotx, 1, 0, 0);
	glRotatef(roty, 0, 1, 0);
	glRotatef(rotz, 0, 0, 1);


	// Animation de la texture
	tempo++;
	if(tempo >= tempomax)
	{
		tempo = 0;
		numBMP++;
		if(numBMP == 3) numBMP = 0;
	}

	glBindTexture(GL_TEXTURE_2D, texture[numBMP]);
	glBegin(GL_QUADS);
		// Front Face
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Top Left Of The Texture and Quad
		// Back Face
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Top Left Of The Texture and Quad
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Bottom Left Of The Texture and Quad
		// Top Face
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Top Left Of The Texture and Quad
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Top Right Of The Texture and Quad
		// Bottom Face
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Top Left Of The Texture and Quad
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Bottom Right Of The Texture and Quad
		// Right face
		glTexCoord2f(1.0f, 0.0f); glVertex3f( 1.0f, -1.0f, -1.0f);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f( 1.0f,  1.0f, -1.0f);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f( 1.0f,  1.0f,  1.0f);	// Top Left Of The Texture and Quad
		glTexCoord2f(0.0f, 0.0f); glVertex3f( 1.0f, -1.0f,  1.0f);	// Bottom Left Of The Texture and Quad
		// Left Face
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-1.0f, -1.0f, -1.0f);	// Bottom Left Of The Texture and Quad
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-1.0f, -1.0f,  1.0f);	// Bottom Right Of The Texture and Quad
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-1.0f,  1.0f,  1.0f);	// Top Right Of The Texture and Quad
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-1.0f,  1.0f, -1.0f);	// Top Left Of The Texture and Quad
	glEnd();

	return TRUE;
}

/****************************************************************************************************/

int InitGL(GLvoid)
{
	// Chargement des textures
	if (!(LoadBMP("image00.bmp",0) &&
		  LoadBMP("image01.bmp",1) &&
		  LoadBMP("image02.bmp",2)
		))
		return FALSE;							// Si on trouve pas les textures on quitte


	glEnable(GL_TEXTURE_2D);				// Texture Mapping activ
	glShadeModel(GL_SMOOTH);				// smooth shading pour que les angles soient moins visible
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);	// background color (r,g,b,alpha) ici c'est noir

	glClearDepth(1.0f);						// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);				// Donne l'ordre a openGL d'utiliser le Z-Buffer (DEPTH Buffer)
	glDepthFunc(GL_LEQUAL);					// le type du test pour le Z-Buffer ici <=
	
	// Qualite des interpolation  des coordonnes des couleurs et des textures
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);			// ici GL_NICEST = qualite maximale

	return TRUE;
}

/****************************************************************************************************/

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)				// Resize And Initialize The GL Window
{
	if (height==0) height=1;					// Pour eviter une division par 0 dans gluPerspective

	glViewport(0, 0, width, height);			// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);				// Selection de la Matrice de Projection
	glLoadIdentity();							// Reset cette matrice

	// Pour que l'affichage ne soit pas deforme par la taille de la fenetre
	// 0.1 et 100 sont respectivement la distance minimale et maximale d'affichage (distance de clipping sur z)
	// 45 c'est l'angle utilise pour la projection 3D
	// Remarque : glMatrixMode permet de choisir la Matrice courrante donc gluPerspective modifie GL_PROJECTION
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	// Remarque : la matrice GL_MODELVIEW contient les information des objets (la scene quoi)
	glMatrixMode(GL_MODELVIEW);					// Selectionne la matrice Modelview
	glLoadIdentity();							// Reset cette matrice
}

/****************************************************************************************************/

GLvoid KillGLWindow(GLvoid)
{
	// Il faut repasser en mode fenetre car certaine carte n'accepte pas qu'on supprime la fentre en mode plein ecran
	if(fullscreen)		
	{
		// mettre NULL et 0 force windows a prendre les parametre par default
		ChangeDisplaySettings(NULL,0);					// On passe en mode fenetre
		ShowCursor(TRUE);								// pointeur souris visible
	}

	if(hRC)
	{
		if(!wglMakeCurrent(NULL,NULL))					// detache hRC de hDC
			MessageBox(NULL,"Le dtachement du DC et du RC a echou.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);

		if (!wglDeleteContext(hRC))						// efface le RC
			MessageBox(NULL,"la suppression  du Rendering Context a echou.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);

		hRC = NULL;
	}


	if (hDC && !ReleaseDC(hWnd,hDC))					// efface le DC
	{
		MessageBox(NULL,"la suppression  du Device Context a echou.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC = NULL;										// Set DC To NULL
	}


	if (hWnd && !DestroyWindow(hWnd))					// Supprime la fenetre
	{
		MessageBox(NULL,"Impossibilit de fermer la fentre.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd = NULL;									// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))			// Are We Able To Unregister Class
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance = NULL;								// Set hInstance To NULL
	}

}

/****************************************************************************************************/

/*	Ce code cre une fentre												*
 *	title			- Texte qui apparait dans la barre de la fenetre		*
 *	width			- Width Of The GL Window Or Fullscreen Mode (longueur)	*
 *	height			- Height Of The GL Window Or Fullscreen Mode (largeur)	*
 *	bits			- bpp (Bits Per Pixel) (8/16/24/32)						*
 *	fullscreenflag	- Use Fullscreen Mode (TRUE) Or Windowed Mode (FALSE)	*/
 
BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;			// Holds The Results After Searching For A Match
	WNDCLASS	wc;						// Windows Class Structure
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style
	RECT		WindowRect;				// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;			// Set Left Value To 0
	WindowRect.right=(long)width;		// Set Right Value To Requested Width
	WindowRect.top=(long)0;				// Set Top Value To 0
	WindowRect.bottom=(long)height;		// Set Bottom Value To Requested Height

	fullscreen=fullscreenflag;			// Set The Global Fullscreen Flag

	// Parametre de la fenetre
	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redessine la fenetre si on bouge ou redimmensionne la fenetre (CS_OWNDC = un seul DC pour la fenetre)
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// Handle de WndProc
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Icone Windows
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Pointeur normal
	wc.hbrBackground	= NULL;									// Pas de background
	wc.lpszMenuName		= NULL;									// Pas besoin de menu
	wc.lpszClassName	= "OpenGL";								// Nom de la Class

	if (!RegisterClass(&wc))									// On enregistre la class dans Windows
	{
		MessageBox(NULL,"Erreur lors de l'enregistrement de la class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}
	
	if (fullscreen)												// Plein cran?
	{
		DEVMODE dmScreenSettings;								// Device Mode (structure qui contient tous les parametres pour le passage en plein ecran)
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Toujours mettre  zro avant d'initialiser (evite des plantages)
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Taille de la structure
		dmScreenSettings.dmPelsWidth	= width;				// Width (longueur)
		dmScreenSettings.dmPelsHeight	= height;				// Height (hauteur)
		dmScreenSettings.dmBitsPerPel	= bits;					// Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN) != DISP_CHANGE_SUCCESSFUL)
		{
			// Si ca foire on propose de passer en mode fentre ou de quitter
			if (MessageBox(NULL,"Le passage en %width x %height plein ecran n'est pas supporte par votre carte.\n Pass en mode fentre?","OpenGL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;		// Fullscreen = FALSE (mode fenetre)
			}
			else
			{
				// Un commentaire pour avertir l'utilisateur que l'application va etre ferm
				MessageBox(NULL,"L'application va etre ferm.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}

	if (fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle = WS_EX_APPWINDOW;							// mettre la fenetre en 1er plan lors de son 1er affichage
		dwStyle = WS_POPUP;										// Creation d'une fenetre pop up qui ne possede pas de bordure (ideal pour le plein cran)
		ShowCursor(FALSE);										// En plein ecran on cache le curseur souris
	}
	else
	{
		dwExStyle = WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// mettre la fenetre en 1er plan lors de son 1er affichage avec une bordure raise edge (je sais pas ce que c'est!)
		dwStyle = WS_OVERLAPPEDWINDOW;							// Fentre avec les boutons minimize/maximize etc...
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Calcule la taille du rectangle necessaire

	// Creation de la fenetre
	if (!(hWnd = CreateWindowEx(dwExStyle,							// Extended Style (defini un peu plus haut)
								"OpenGL",							// Class Name
								title,								// Titre de la fentre
								dwStyle |							// Window Style (defini un peu plus haut)
								WS_CLIPSIBLINGS |					// Required Window Style (necessaire pour que OpenGL fonctionne correctement)
								WS_CLIPCHILDREN,					// Required Window Style (necessaire pour que OpenGL fonctionne correctement)
								0, 0,								// Position de la fentre
								WindowRect.right-WindowRect.left,	// Calcul la longueur de la fentre
								WindowRect.bottom-WindowRect.top,	// Calcul la hauteur de la fentre
								NULL,								// No Parent Window
								NULL,								// No Menu
								hInstance,							// Instance
								NULL)))								// Ne rien envoyer  WM_CREATE
	{
		KillGLWindow();								// Reset The Display si la creation a echou
		MessageBox(NULL,"Erreur lors de la creation de la fentre.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// Parametre des pixels
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// taille de la structure
		1,											// Version (toujours 1 apparemment)
		PFD_DRAW_TO_WINDOW |						// Format Must Support Window
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							// Must Support Double Buffering
		PFD_TYPE_RGBA,								// Format des pixels RGBA (Red Green Blue Alpha)
		bits,										// bpp
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)  
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer (pour afficher dans la surface visible de la fenetre)
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))							// On recupere de Device Context
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create a GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Windows a t'il trouver le Pixel Format demander?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// On accroche le Pixel Format au DC
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))				// creation du RC
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))					// accroche la RC au DC
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);						// Affiche la fenetre
	SetForegroundWindow(hWnd);						// Slightly Higher Priority
	SetFocus(hWnd);									// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);					// Set Up Our Perspective GL Screen

	if (!InitGL())									// Initialise OpenGL
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Erreur lors de l'initialisation.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	return TRUE;									// Success
}

/****************************************************************************************************/

LRESULT	CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{

	switch(uMsg)
	{
	case WM_ACTIVATE:	// Si la fenetre est minimise on arrete l'affichage
	{
		if (!HIWORD(wParam))			// Check Minimization State
			active=TRUE;				// Program Is Active
		else
			active=FALSE;				// Program Is No Longer Active
		return 0;						// Return To The Message Loop
	}
	
	case WM_CLOSE:						// Message de fermeture?
	{
		PostQuitMessage(0);				// envoie le message de fermeture
		return 0;
	}

	case WM_SIZE:						// Redimenssionne la fentre
	{
		ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));		// LoWord=Width, HiWord=Height
		return 0;						// Jump Back
	}

	case WM_KEYDOWN:					// Regarde si une touche a ete appuyer
	{
		keys[wParam] = TRUE;			// Si oui on le signale dans la matrice keys
		return 0;						// Jump Back
	}

	case WM_KEYUP:							// Has A Key Been Released?
	{
		keys[wParam] = FALSE;					// If So, Mark It As FALSE
		return 0;						// Jump Back
	}
}

	return	DefWindowProc(hWnd,uMsg,wParam,lParam);	// Windows gere tous les autres messages
}


/****************************************************************************************************/
// Il faut avoir au prealable cr une matrice qui va contenir les pointeurs sur ces testures.
// GLuint	texture[nb_texture];
// Index est donc le n de la ligne de la matrice texture dans lequel va etre sauvegarde le pointeur

BOOL LoadBMP(char *fichier, int index)
{
	BOOL Status = FALSE;						// Pour tester si tout c'est bien passer
	AUX_RGBImageRec *TextureImage[1];			// Buffer temporaire
	FILE *File=NULL;


	if (!fichier) return NULL;					// On teste la presence du fichier
	File = fopen(fichier,"r");
	if (File) fclose(File);						// Ferme le fichier


	memset(TextureImage,0,sizeof(void *)*1);				// Set The Pointer To NULL

	// Charge le bitmap,
	if (TextureImage[0] = auxDIBImageLoad(fichier))
	{
		Status=TRUE;							// Set The Status To TRUE

		glGenTextures(1, &texture[index]);					// Create The Texture

		// Typical Texture Generation Using Data From The Bitmap
		glBindTexture(GL_TEXTURE_2D, texture[index]);

		// Generate The Texture
		glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);

		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);	// Linear Filtering
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	// Linear Filtering
	}

	if (TextureImage[0])							// If Texture Exists
	{
		if (TextureImage[0]->data)					// If Texture Image Exists
		{
			free(TextureImage[0]->data);			// Free The Texture Image Memory
		}

		free(TextureImage[0]);						// Free The Image Structure
	}


	return Status;
}